package net.shrine.messagequeuemiddleware

import cats.effect.IO
import net.shrine.protocol.version.{Envelope, MomQueueName}
object MessageTranslationHandler {

  def translateMessage(toQueueName: MomQueueName, envelope: Envelope): IO[Envelope] = {
    MessageTranslationStrategy.getStrategy(envelope).flatMap(m =>
      m.fold(IO(envelope))(e => e._1.translateMesssage(toQueueName, e._2, e._3)))
  }
}
